unit FileVLit;
{                                 Programmed by

                                  Andrea Molino
                               easytarg@mbox.vol.it

  TFileListViewLite
  TFileListLitePopup
  TDirectoryComboLite
  TFileNameEditLite

  In this file you can found some components to implement an "Enhanced Open Dialog".
  You can try to understand as they work and excuse me: I have not enough time to
  document my work.

  Fell Free of use this code as you want in NON COMMERCIAL Application:
  send me an E-mail to tell me what You think about this component!.

  If You want to use it in COMMERCIAL Application, please, send me a little
  money contribution and remember of me in the "About Box"!

  Please send me any suggestion and bug report.

}

{ Improvements:

    - Complete support to the Drag&Drop with the System Shell.
    - Added TShellChangeNotifyThread to refresh the view on Shell changes.
}

interface

{$R FileVlit.RES}

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Menus,
  ComCtrls, CommCtrl, StdCtrls, Ole2, ShlObj, ShellAPI, FileDrop;

Const
  DefaultMask = '*.*';
  FullFileTypes = FILE_ATTRIBUTE_READONLY Or FILE_ATTRIBUTE_HIDDEN Or FILE_ATTRIBUTE_SYSTEM;
  Slashes: array [False..True] of PChar = ('','\');
  SysFoldid: Array [0..2] Of Integer = (CSIDL_DRIVES, CSIDL_NETWORK, CSIDL_BITBUCKET);
  SysFoldNm: Array [0..2] Of String = ('Drives', 'NetWork', 'Recycled');

  CLSID_ShellLinkV: Ole2.TGUID = (
    D1:$00021401; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IShellLinkV: Ole2.TGUID = (
    D1:$000214EE; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));
  IID_IPersistFileV: System.TGUID = (
    D1:$0000010B; D2:$0000; D3:$0000; D4:($C0,$00,$00,$00,$00,$00,$00,$46));

  FILE_NOTIFY_CHANGE_ALL = $00000001 Or $00000002 Or $00000004 Or $00000008 Or $00000040;
                          //No: Last Write, Last Access, Security

Type
  TFileListLitePopup = Class;
  TDirectoryComboLite = Class;
  TFileNameEditLite = Class;

  TFileListViewAttr = (flvReadOnly, flvHidden, flvSystem);
  TFileListViewType = Set Of TFileListViewAttr;

  TFileViewLanguage = (lnSystemDefault, lnUserDefault, lnEnglish, lnItalian, lnFrench, lnGerman, lnSpanish);
  TSortedBy = (sbName, sbSize, sbType, sbDate, sbAttr, sbNameInv, sbSizeInv, sbTypeInv, sbDateInv, sbAttrInv);
  TViewIconStyle = (visIcon, visSmallIcon, visList, visReport);

  TFileListViewViewChangeEvent = Procedure(Sender: TObject; Style: TViewStyle) of object;
  TFileListViewDirChangeEvent = Procedure(Sender: TObject; OldDir, Directory: String; CanPrev: Boolean) of object;
  TFileListViewFileSelectEvent = Procedure(Sender: TObject; FileName: String) of object;
  TFileListViewDropEvent = Procedure(Files: TStrings; X, Y: Integer) of object;

  TShellChangeNotifyThread = Class(TThread)
  private
    FLastPath: String;
    FChangeHandle: THandle;
    FOnChangeNotify: TNotifyEvent;
  protected
    procedure Execute; Override;
  public
    Constructor Create(CreateSuspended: Boolean);
    Procedure InitMonitor(Path: String);
    Procedure ResetPendings;
    Property OnChangeNotify: TNotifyEvent Read FOnChangeNotify Write FOnChangeNotify;
  end;

  TFileListViewLite = Class(TCustomListView)
  Private
    StrResBase: Integer;              // Base Index for String Language RES
    FPopupMenu: TFileListLitePopup;
    FDirCombo: TDirectoryComboLite;
    FFileEdit: TFileNameEditLite;
    FDirectory: String;
    FDirectorySize: Integer;
    FMask: String;
    FLanguage: TFileViewLanguage;
    FFileViewType: TFileListViewType;
    FSortedBy: TSortedBy;
    FViewIconStyle: TViewIconStyle;
    FReadEnabled: Boolean;
    FNetWorkEnabled: Boolean;
    FResolveLink: Boolean;
    FExecuteOpen: Boolean;
    FPoPupMenuEnabled: Boolean;
    FileImageList: TImageList;
    FileLargeImageList: TImageList;
    FLastColumnSorted: Integer;
    FDirection: Boolean;
    OldName, OldCapt: String;
    OldDirectory: String;
    FileDroppedList: TStrings;
    DragFileInt: TDropFileSource;
    FDragFileEnabled: Boolean;
    FDragPoint: TPoint;
    ExecutingDragFile: Boolean;
    FReading: Boolean;
    ChgNotifyThread: TShellChangeNotifyThread;
    FOnAfterRead: TNotifyEvent;
    FOnViewChange: TFileListViewViewChangeEvent;
    FOnDirectoryChange: TFileListViewDirChangeEvent;
    FOnFileSelect: TFileListViewFileSelectEvent;
    FOnFileDrop: TFileListViewDropEvent;
    Function  GetDrive: char;
    Function  GetFileName: string;
    Function  GetFilePath: string; virtual;
    Function  GetViewIconStyle: TViewIconStyle;
    Function  GetAllNumber: Integer;
    Function  GetSelNumber: Integer;
    Function  GetSelSize: Integer;
    Procedure SetDrive(Value: char);
    Procedure SetDirCombo(Value: TDirectoryComboLite);
    Procedure SetFileEdit(Value: TFileNameEditLite);
    Procedure SetFileName(NewFile: string);
    Procedure SetLanguage(Value: TFileViewLanguage);
    Procedure SetFileViewType(Value: TFileListViewType);
    Procedure SetDirectory(NewDirectory: string);
    Procedure SetMask(NewMask: string);
    Procedure SetSortedBy(Value: TSortedBy);
    Procedure SetViewIconStyle(Value: TViewIconStyle);
    Procedure SetPoPupMenuEnabled(Value: Boolean);
    Procedure WMDROPFILES(var Message: TWMDropFiles); message WM_DROPFILES;
  Protected
    Procedure CreateWnd; Override;
    Procedure Loaded; override;
    Procedure Change(Item: TListItem; Change: Integer); Override;
    Procedure ColClick(Column: TListColumn); Override;
    Procedure DblClick; Override;
    Procedure KeyDown(var Key: Word; Shift: TShiftState); Override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); Override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); Override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); Override;
    Function  CanEdit(Item: TListItem): Boolean; Override;
    Procedure Edit(const Item: TLVItem); Override;
    Procedure Notification(AComponent: TComponent; Operation: TOperation); Override;
    Procedure ReadSpecialFolder(idCont, idRoot: PItemIDList; Fold: Integer; UseItem, UseDisp: Boolean);
    Procedure ReadDeskTopFolder;
    Procedure ReadSystemResource;
    Procedure ReadNetworkResource(idRoot: PItemIDList);
    Procedure ReadRecycledBin;
    Function  ReadDirectoryFiles(FileMask: string; Attributes: DWORD): Boolean;
    Procedure ReadFileNames; virtual;
    Procedure SortBy(SType: TSortedBy);
    Function  IsDirReadOnly: Boolean;
    Function  IsSysFold: Boolean;
    Function  IsDeskLink: Boolean;
    Function  IsDir: Boolean;
    Function  IsUnit: Boolean;
    Function  IsNetCont: Boolean;
    Function  GetDriveTypeStr(Root: String): String;
    Procedure ShellOpenEx(Com, Par: String);
    Procedure SendToPath(Path: String);
    Procedure ShellChangeNotify(Sender: TObject);
  public
    Constructor Create(AOwner: TComponent); Override;
    Destructor Destroy; Override;
    Procedure ReRead;
    Function  PrevDirectory: Boolean;
    Procedure Rename;
    Procedure DeleteFiles;
    Procedure NewFolder;
    Procedure SendTo(Path: String);
    Procedure MoveTo(Path: String);
    Procedure ShellOpen;
    Function GetSelectedFiles(FList: TStrings; Dir: Boolean): Integer;
    Property Drive: Char Read GetDrive Write SetDrive;
    Property Directory: String Read FDirectory Write SetDirectory;
    Property FileName: String Read GetFilePath Write SetFileName;
    Property DirectorySize: Integer Read FDirectorySize;
    Property AllFileNumber: Integer Read GetAllNumber;
    Property SelectedNumber: Integer Read GetSelNumber;
    Property SelectedSize: Integer Read GetSelSize;
    Property Reading: Boolean Read FReading;
  published
    Property DirCombo: TDirectoryComboLite Read FDirCombo Write SetDirCombo;
    Property FileEdit: TFileNameEditLite Read FFileEdit Write SetFileEdit;
    Property FileViewType: TFileListViewType Read FFileViewType Write SetFileViewType
                                              Default [flvReadOnly, flvHidden, flvSystem];
    Property Language: TFileViewLanguage Read FLanguage Write SetLanguage;
    Property Mask: string Read FMask Write SetMask;
    Property SortedBy: TSortedBy read FSortedBy Write SetSortedBy Default sbName;
    Property ViewIconStyle: TViewIconStyle Read GetViewIconStyle Write SetViewIconStyle;
    Property NetWorkEnabled: Boolean Read FNetWorkEnabled Write FNetWorkEnabled Default False;
    Property ReadEnabled: Boolean Read FReadEnabled Write FReadEnabled Default False;
    Property ResolveLink: Boolean Read FResolveLink Write FResolveLink Default False;
    Property ExecuteOpen: Boolean Read FExecuteOpen Write FExecuteOpen Default False;
    Property PoPupMenuEnabled: Boolean Read FPoPupMenuEnabled Write SetPoPupMenuEnabled Default True;
    Property DragFileEnabled: Boolean Read FDragFileEnabled Write FDragFileEnabled;
    property Align;
    property BorderStyle;
    property Color;
    property Ctl3D;
    property DragMode;
    property ReadOnly;
    property Font;
    property HideSelection;
    property ParentShowHint;
    property ShowHint;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property MultiSelect;
    property DragCursor;
    property OnAfterRead: TNotifyEvent Read FOnAfterRead Write FOnAfterRead;
    property OnViewChange: TFileListViewViewChangeEvent Read FOnViewChange Write FOnViewChange;
    property OnFileSelect: TFileListViewFileSelectEvent Read FOnFileSelect Write FOnFileSelect;
    property OnDirectoryChange: TFileListViewDirChangeEvent Read FOnDirectoryChange Write FOnDirectoryChange;
    property OnFileDrop: TFileListViewDropEvent read FOnFileDrop write FOnFileDrop;
    property OnClick;
    property OnDblClick;
    property OnChange;
    property OnChanging;
    property OnColumnClick;
    property OnCompare;
    property OnDeletion;
    property OnEdited;
    property OnEditing;
    property OnEnter;
    property OnExit;
    property OnInsert;
    property OnDragDrop;
    property OnDragOver;
    property OnStartDrag;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
  End;

  TFileListLitePopup = Class(TPopupMenu)
  Private
    FFileListView: TFileListViewLite;
    SendToList: TStrings;
    Procedure SetFileListView(Value: TFileListViewLite);
  Protected
    Function ExtNewItem(const ACaption: string; AShortCut: TShortCut;
                         AChecked, AEnabled, ARadio: Boolean;
                          AGroup: Integer; AOnClick: TNotifyEvent;
                           hCtx: Word; const AName: string): TMenuItem;
    Procedure GetSendTo;
    Procedure GeneralItemClick(Sender: TObject);
  Public
    Constructor Create(AOwner: TComponent); Override;
    Destructor Destroy; Override;
    Procedure BuildItems(StrResBase: Integer);
    Procedure Popup(X, Y: Integer); Override;
    Property FileListView: TFileListViewLite Read FFileListView Write SetFileListView;
  End;

  TDirectoryComboLite = Class(TCustomComboBox)
  Private
    FDirectory: String;
    DirLst: TStringList;
    FFileListView: TFileListViewLite;
    ImageList: TImageList;
    DriveItem: Integer;
    InhibitItemIndex: Boolean;
    FOnDirectoryChange: TFileListViewDirChangeEvent;
    Function  GetDrive: char;
    Procedure SetDrive(Value: char);
    procedure SetDirectory(NewDirectory: string);
    Procedure SetFileListView(Value: TFileListViewLite);
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;
    procedure CNDrawItem(var Message: TWMDrawItem); message CN_DRAWITEM;
    procedure ResetItemHeight;
    function  GetItemIndex: Integer;
    procedure SetItemIndex(Value: Integer);
  protected
    procedure CreateWnd; override;
    procedure DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState); override;
    procedure Click; override;
    Function  FindDirItem(Dir: String): Integer;
    procedure DisplayDir; virtual;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    Procedure KeyDown(var Key: Word; Shift: TShiftState); Override;
  public
    constructor Create(AOwner: TComponent); Override;
    Destructor Destroy; Override;
    procedure BuildList;
    Function PrevDirectory: Boolean;
    Property Drive: Char Read GetDrive Write SetDrive;
    Property Directory: String Read FDirectory Write SetDirectory;
    property ItemIndex: Integer read GetItemIndex write SetItemIndex;
  published
    property Color;
    property Ctl3D;
    Property FileListView: TFileListViewLite Read FFileListView Write SetFileListView;
    property DragMode;
    property DragCursor;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnDirectoryChange: TFileListViewDirChangeEvent Read FOnDirectoryChange Write FOnDirectoryChange;
    property OnMouseDown;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDown;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDrag;
  end;

  TFileNameEditLite = Class(TEdit)
  Private
    FFileListView: TFileListViewLite;
    Procedure SetFileListView(Value: TFileListViewLite);
  Protected
    Procedure KeyPress(var Key: Char); Override;
    Procedure Notification(AComponent: TComponent; Operation: TOperation); Override;
  Published
    Property FileListView: TFileListViewLite Read FFileListView Write SetFileListView;
  End;

Function GetStringResIndex(Language: TFileViewLanguage): Integer;
Function DoSHFileOp(Handle: THandle; Operation: UINT;
                      Items: TStrings; TargetDir: String; Var Aborted: Boolean): Boolean;
Function GetSHSpecialFolderInfo(Handle: THandle; Var Info: TSHFileInfo; Root: Integer): Boolean;
Function GetSHLinkedFileFromLink(Handle: THandle; LinkFileName: String): String;
Function GetSHRealPath(Handle: THandle; var Dest: string; Root: Integer): Boolean;
Function GetNiceName(const ShellFolder: IShellFolder; IDList: PItemIDList; Flags: DWORD): String;
Function FileTimeToFileDateStr(FileTime: TFileTime): String;
Function SlashSep(Path, S: String): String;
Function DirectoryExists(Path: String): Boolean;
Function GetDiskSize(Root: String): LongInt;

Function GetItemHeight(Font: TFont): Integer;
Function NumbToIntDef(SNumb: String; DefVal: LongInt): LongInt;
Function CustomSortProc(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;

Procedure Register;

implementation

//uses Consts, ComStrs;


procedure Register;
Begin
  RegisterComponents('MyGold', [TFileListViewLite]);
  RegisterComponents('MyGold', [TFileNameEditLite]);
  RegisterComponents('MyGold', [TDirectoryComboLite]);
End;

{ ******************* GENERAL FUNCTION **************************** }

{
  LANG_BULGARIAN                   = $02;
  LANG_CHINESE                     = $04;
  LANG_CROATIAN                    = $1a;
  LANG_CZECH                       = $05;
  LANG_DANISH                      = $06;
  LANG_DUTCH                       = $13;
  LANG_ENGLISH                     = $09;    // Supported
  LANG_FINNISH                     = $0b;
  LANG_FRENCH                      = $0c;    // Supported
  LANG_GERMAN                      = $07;    // Supported
  LANG_GREEK                       = $08;
  LANG_HUNGARIAN                   = $0e;
  LANG_ICELANDIC                   = $0f;
  LANG_ITALIAN                     = $10;    // Supported
  LANG_JAPANESE                    = $11;
  LANG_KOREAN                      = $12;
  LANG_NORWEGIAN                   = $14;
  LANG_POLISH                      = $15;
  LANG_PORTUGUESE                  = $16;
  LANG_ROMANIAN                    = $18;
  LANG_RUSSIAN                     = $19;
  LANG_SLOVAK                      = $1b;
  LANG_SLOVENIAN                   = $24;
  LANG_SPANISH                     = $0a;    // Supported
  LANG_SWEDISH                     = $1d;
  LANG_TURKISH                     = $1f;
}

Function GetStringResIndex(Language: TFileViewLanguage): Integer;
Var
  LangID: Integer;
  ResHeader: String;
Begin
  Case Language Of
    lnSystemDefault: LangID := GetSystemDefaultLangID And $3FF;
    lnUserDefault:   LangID := GetUserDefaultLangID And $3FF;
    lnEnglish:       LangID := LANG_ENGLISH;
    lnItalian:       LangID := LANG_ITALIAN;
    lnFrench:        LangID := LANG_FRENCH;
    lnGerman:        LangID := LANG_GERMAN;
    lnSpanish:       LangID := LANG_SPANISH;
    Else LangID := GetSystemDefaultLangID And $3FF;
  End;
  Result := LangID * 100;
  ResHeader := LoadStr(Result);
  If ResHeader = '' Then Result := LANG_ENGLISH * 100;
End;

Function DoSHFileOp(Handle: THandle; Operation: UINT;
                      Items: TStrings; TargetDir: String; Var Aborted: Boolean): Boolean;
Var
  I, Ret: Integer;
  FileOpDesc: TSHFileOpStruct;
  FileNames: String;
  Target: Array [0..MAX_PATH] Of Char;
Begin
  Aborted := False;
  FileNames := '';
  For I := 0 To Items.Count-1 Do
    FileNames := FileNames + Items[I] + #0;
  StrPCopy(Target, TargetDir + #0);
  With FileOpDesc Do
  Begin
    Wnd := Handle;
    wFunc := Operation;
    pFrom := PChar(FileNames + #0);
    pTo := Target;
    fFlags := FOF_ALLOWUNDO;
    hNameMappings := Nil;
    lpszProgressTitle := '';
  End;
  Try
    Ret := SHFileOperation(FileOpDesc);
    Aborted := FileOpDesc.fAnyOperationsAborted;
  Except
    Ret := 1;
  End;
  Result := (Ret = 0);
End;

Function GetSHSpecialFolderInfo(Handle: THandle; Var Info: TSHFileInfo; Root: Integer): Boolean;
Var
  idRoot: PItemIDList;
Begin
  Result := False;
  Try
    If SHGetSpecialFolderLocation(Handle, Root, idRoot) = NOERROR Then
    Begin
      SHGetFileInfo(PChar(idRoot), 0, Info, SizeOf(Info), SHGFI_PIDL Or
                     SHGFI_SYSICONINDEX Or SHGFI_SMALLICON Or
                     SHGFI_DISPLAYNAME Or SHGFI_TYPENAME);
      If Info.szDisplayName <> '' Then Result := True;
    End;
  Except
  End;
End;

Function GetSHLinkedFileFromLink(Handle: THandle; LinkFileName: String): String;
{Var
  Buffer: Array [0..2048] Of Char;
  FStream: TFileStream;
  P: Pchar;
  L: Integer;
Begin                  // This is a Shit Procedure but..... (Look Down)
  Result := '';
  FStream := TFileStream.Create(LinkFileName, fmOpenRead);
  L := FStream.Read(Buffer, SizeOf(Buffer));
  FStream.Free;
  P := Buffer;
  L := Integer(P) + L;
  While (Integer(P) < L) And (Result = '') Do
  Begin
    P := P + Length(StrPas(P)) + 1;
    If Pos(':\', StrPas(P)) = 3 Then Result := StrPas(P+1);
  End;
  If Result <> '' Then
    While (Integer(P) < L) Do
    Begin
      P := P + Length(StrPas(P)) + 1;
      If Pos('\\', StrPas(P)) > 0 Then Break
      Else If Pos(':\', StrPas(P)) = 2 Then
      Begin
        Result := StrPas(P);
        Break;
      End;
    End
  Else
  Begin
    P := Buffer;
    While (Integer(P) < L) Do
    Begin
      P := P + Length(StrPas(P)) + 1;
      If Pos('\\', StrPas(P)) = 1 Then Result := StrPas(P);
    End;
  End;}

Var                   // ....this have some problems with long file names!!)
  //hres: HRESULT;
  psl: IShellLink;
  //ClFact: IClassFactory;
  szGotPath : array[0..MAX_PATH-1] of char;
  szDescription : array[0..MAX_PATH-1] of char;
  wfd: TWin32FindData;
  ppf: IPersistFile;
  wsz: array[0..MAX_PATH-1] of WideChar;
Begin
  Result := '';
  CoInitialize(Nil);
  If CoCreateInstance(CLSID_ShellLinkV, Nil, CLSCTX_INPROC_SERVER, IID_IShellLinkV, psl) = S_OK Then
  Begin
    If psl.QueryInterface(IID_IPersistFileV, ppf) = S_OK Then
    Begin
     MultiByteToWideChar(CP_ACP, 0,@LinkFileName[1],-1,wsz,MAX_PATH);
     If ppf.Load(wsz, STGM_READ) = S_OK Then
     Begin
       //If psl.Resolve(Handle, SLR_ANY_MATCH Or SLR_NO_UI) = S_OK Then
       //Begin
         If psl.GetPath(szGotPath, MAX_PATH, wfd, SLGP_SHORTPATH) <> S_OK Then Exit;
         If psl.GetDescription(szDescription, MAX_PATH) <> S_OK Then Exit;
         // Result := StrPas(szGotPath) + '|' + StrPas(szDescription);
         Result := StrPas(szGotPath);
       //End;
     End;
     ppf.Release;
    End;
    //psl.Release;
  End;
  CoUninitialize;
End;

Function GetSHRealPath(Handle: THandle; Var Dest: String; Root: Integer): Boolean;
var
  ShellMalloc: IMALLOC;
  shBuff: PChar;
  idRoot: PItemIDList;
Begin
  Result := False;
  SetLength(Dest, MAX_PATH);  // Make sure their will be enough room in dest.
  if CoGetMalloc(1, ShellMalloc) = NOERROR then
  Begin
    try
      shBuff := PChar(ShellMalloc.Alloc(MAX_PATH)); // Shell allocate buffer.
      if assigned(shBuff) then
      Begin
        try
          SHGetSpecialFolderLocation(Handle, Root, idRoot);
          If SHGetPathFromIDList(idRoot, shBuff) Then
          Begin
            Dest := shBuff;
            Result := True;
          End;
        Except
          ShellMalloc.Free(idRoot); // Clean up after ourselves
        End;
      End;
    finally
      ShellMalloc.Release; // Clean-up.
    End;
  End;
End;

Function GetNiceName(const ShellFolder: IShellFolder; IDList: PItemIDList; Flags: DWORD): String;
Var                                          //Thanks to Frank Kroeger <FKroeger@tkc.de>
  Str: TStrRet;
  Name: String;
Begin
  Name := '';
  If ShellFolder.GetDisplayNameOf(IDList, Flags, Str) = NOERROR Then
  Begin
    Case Str.uType of
      STRRET_WSTR:
        Begin
          // Make sure enough mem is available initially.
          SetLength(Name, MAX_PATH+1);
          // This resets the length and copies the string into Name
          SetLength(Name, WideCharToMultiByte(CP_ACP, 0, Str.pOleStr, -1,
                                              pChar(Name), MAX_PATH, NIL, NIL));
        End;
      STRRET_OFFSET: Name := PChar(Longint(IDList) + Str.uOffset);
      STRRET_CSTR:   Name := Str.cStr;
    End;
  End;
  Result := Name;
end;

Function FileTimeToFileDateStr(FileTime: TFileTime): String;
Var
  LocFTime: TFileTime;
  SysFTime: TSystemTime;
  DateStr: String;
  TimeStr: String;
  LocationInSpace: String;
  Dt, Tm: TDateTime;
Begin
  FileTimeToLocalFileTime(FileTime, LocFTime);
  FileTimeToSystemTime(LocFTime, SysFTime);
  Try
    With SysFTime Do
    begin
      Dt := EncodeDate(wYear, wMonth, wDay);
      DateStr := DateToStr(Dt);
      Tm := EncodeTime(wHour, wMinute, wSecond, wMilliseconds);
      Timestr := TimeToStr(Tm);
      LocationInSpace := DateStr + '   ' + TimeStr;
    end;
    Result := DateTimeToStr(StrToDateTime(LocationInSpace));
  Except
    Result := '';
  End;
End;

Function SlashSep(Path, S: String): String;
Begin
  If Path = '' Then Result := ''
  Else Result := Format('%s%s%s',[Path, Slashes[Path[Length(Path)] <> '\'], S]);
End;

Function DirectoryExists(Path: String): Boolean;
Var
  FileInfo: TWin32FindData;
  FindFileH: THandle;
  Aux: DWORD;
Begin
  If Pos('\\', Path) = 1 Then Result := True
  Else
  Begin
    Result := False;
    FindFileH := FindFirstFile(PChar(Path), FileInfo);
    If FindFileH <> INVALID_HANDLE_VALUE then
    Begin
      Windows.FindClose(FindFileH);
      If (FileInfo.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) > 0 Then
        Result := True;
    End;
    If Not Result Then Result := GetDiskFreeSpace(PChar(Path), Aux, Aux, Aux, Aux);
  End;
End;

Function GetDiskSize(Root: String): LongInt;
Var
  SpC, BpS, NfC, TnC: DWORD;
  Aux: Double;
Begin
  GetDiskFreeSpace(PChar(Root), SpC, BpS, NfC, TnC);
  Aux := (TnC / 1024) * BpS * SpC;
  Result := Round(Aux);
End;

Function GetItemHeight(Font: TFont): Integer;
var
  DC: HDC;
  SaveFont: HFont;
  Metrics: TTextMetric;
begin
  DC := GetDC(0);
  SaveFont := SelectObject(DC, Font.Handle);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  Result := Metrics.tmHeight;
end;

Function NumbToIntDef(SNumb: String; DefVal: LongInt): LongInt;
Var
  I: Integer;
  Aux: String;
Begin
  Aux := '';
  For I := 1 To Length(SNumb) Do
  Begin
    If SNumb[I] = ' ' Then Break;
    If SNumb[I] <> ThousandSeparator Then Aux := Aux + SNumb[I];
  End;
  Result := StrToIntDef(Aux, DefVal);
End;

Function CustomSortProc(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
Begin
  Result := 0;
  If (TListItem(Item1).SubItems[3][1] = 'X') And (TListItem(Item2).SubItems[3][1] <> 'X') Then Result := -1
  Else If (TListItem(Item2).SubItems[3][1] = 'X') And (TListItem(Item1).SubItems[3][1] <> 'X') Then Result := 1
  Else If (TListItem(Item1).SubItems[3][1] = 'd') And (TListItem(Item2).SubItems[3][1] <> 'd') Then Result := -1
  Else If (TListItem(Item2).SubItems[3][1] = 'd') And (TListItem(Item1).SubItems[3][1] <> 'd') Then Result := 1
  Else
    Case ParamSort Of
      1, 6:  Result := lstrcmp(PChar(TListItem(Item1).Caption),
                                PChar(TListItem(Item2).Caption));
      2, 7:  Result := NumbToIntDef(TListItem(Item1).SubItems[0], -1) -
                        NumbToIntDef(TListItem(Item2).SubItems[0], -1);
      3, 8:  Result := lstrcmp(PChar(TListItem(Item1).SubItems[1]),
                                PChar(TListItem(Item2).SubItems[1]));
      4, 9:  Try
               If StrToDateTime(TListItem(Item1).SubItems[2]) <
                 StrToDateTime(TListItem(Item2).SubItems[2]) Then Result := 1
               Else Result := -1;
             Except
               Result := 1;
               If TListItem(Item1).SubItems[2] = '' Then Result := 1
               Else If TListItem(Item2).SubItems[2] = '' Then Result := -1;
             End;
      5, 10: Result := lstrcmp(PChar(TListItem(Item1).SubItems[3]),
                                PChar(TListItem(Item2).SubItems[3]));
    End;
  If ParamSort > 5 Then Result := Result * (-1);
End;



{ ************************** TShellChangeNotifyThread ************************ }

Constructor TShellChangeNotifyThread.Create(CreateSuspended: Boolean);
Begin
  Inherited Create(CreateSuspended);
  Priority := tpIdle;
  FreeOnTerminate := True;
  FLastPath := '';
  FChangeHandle := INVALID_HANDLE_VALUE;
  FOnChangeNotify := Nil;
End;

Procedure TShellChangeNotifyThread.InitMonitor(Path: String);
Begin
  If Path = '' Then
  Begin
    If Not Suspended Then Suspend;

    If FChangeHandle <> INVALID_HANDLE_VALUE Then
      FindCloseChangeNotification(FChangeHandle);

    FChangeHandle := INVALID_HANDLE_VALUE;
  End
  Else If UpperCase(Path) <> UpperCase(FLastPath) Then
  Begin
    If Not Suspended Then Suspend;

    If FChangeHandle <> INVALID_HANDLE_VALUE Then
      FindCloseChangeNotification(FChangeHandle);

    FChangeHandle := FindFirstChangeNotification(PChar(Path), False, FILE_NOTIFY_CHANGE_ALL);
    WaitForSingleObject(FChangeHandle, 0);
    FindNextChangeNotification(FChangeHandle);

    FLastPath := Path;

    If FChangeHandle <> INVALID_HANDLE_VALUE Then
      If Suspended Then Resume;
  End;
End;

Procedure TShellChangeNotifyThread.ResetPendings;
Begin
  If Not Suspended Then Suspend;

  FindNextChangeNotification(FChangeHandle);
  While WaitForSingleObject(FChangeHandle, 0) = WAIT_OBJECT_0 Do
    FindNextChangeNotification(FChangeHandle);

  If Suspended Then Resume;
End;

Procedure TShellChangeNotifyThread.Execute;
Begin
  While Not Terminated Do
  Begin
    If Terminated Then Exit;
    Sleep(300);
    If FChangeHandle <> INVALID_HANDLE_VALUE Then
    Begin
      If WaitForSingleObject(FChangeHandle, 0) = WAIT_OBJECT_0 Then
      Begin
        Try
          Sleep(500);
          FindNextChangeNotification(FChangeHandle);
          While WaitForSingleObject(FChangeHandle, 0) = WAIT_OBJECT_0 Do
            FindNextChangeNotification(FChangeHandle);
          If Assigned(FOnChangeNotify) Then FOnChangeNotify(Self);
        Except
        End;
        FindNextChangeNotification(FChangeHandle);
      End;
    End;
  End;
End;



{ ************************** TFileListViewLite **************************** }
{ ************************** CREATE / DESTROY ***************************** }

Constructor TFileListViewLite.Create(AOwner: TComponent);
Var
  Sfi: TShfileInfo;
Begin
  inherited Create(AOwner);
  FileImageList := TImageList.Create(Self);
  FileLargeImageList := TImageList.Create(Self);
  Try
    FileImageList.Handle :=
      SHGetFileInfo('', 0, Sfi, SizeOf(TShfileInfo),
        SHGFI_SYSICONINDEX Or SHGFI_SMALLICON);
    FileImageList.ShareImages := True;
    SmallImages := FileImageList;

    FileLargeImageList.Handle :=
      SHGetFileInfo('', 0, Sfi, SizeOf(TShfileInfo),
        SHGFI_SYSICONINDEX Or SHGFI_LARGEICON);
    FileLargeImageList.ShareImages := True;
    LargeImages := FileLargeImageList;
  except;
  End;
  FileDroppedList := TStringList.Create;
  DragFileInt := TDropFileSource.Create;
  FDragPoint.X := -1;
  FDragFileEnabled := False;
  ExecutingDragFile := False;
  FLanguage := lnUserDefault;
  StrResBase := GetStringResIndex(lnUserDefault);    // Get Base Index for Language

  FPopupMenu := TFileListLitePopup.Create(Self);
  FPopupMenu.BuildItems(StrResBase);
  FPopupMenu.AutoPopup := True;
  FPopupMenu.FileListView := Self;
  PopupMenu := FPopupMenu;
  GetDir(0, FDirectory);
  FMask := DefaultMask;
  MultiSelect := False;
  ViewStyle := vsList;
  FViewIconStyle := visList;
  FSortedBy := sbName;
  FReadEnabled := False;
  FReading := False;
  FNetWorkEnabled := False;
  FResolveLink := False;
  FExecuteOpen := False;
  FLastColumnSorted := -1;
  FDirection := False;
  FPoPupMenuEnabled := True;

  If Not (csDesigning In ComponentState) Then
  Begin
    ChgNotifyThread := TShellChangeNotifyThread.Create(True);
    ChgNotifyThread.OnChangeNotify := ShellChangeNotify;
  End;

  FOnAfterRead := Nil;
  FOnViewChange := Nil;
  FOnDirectoryChange := Nil;
  FOnFileSelect := Nil;
  FOnFileDrop := Nil;
  FFileViewType := [flvReadOnly, flvHidden, flvSystem];
End;

Destructor TFileListViewLite.Destroy;
Begin
  If Not (csDesigning In ComponentState) Then
  Begin
    ChgNotifyThread.InitMonitor('');
    ChgNotifyThread.Terminate;
  End;
  FPopupMenu.Free;
  FileImageList.Free;
  FileLargeImageList.Free;
  FileDroppedList.Free;
  DragFileInt.Free;
  Inherited Destroy;
End;


{ **************************** PRIVATE ********************************** }

Function TFileListViewLite.GetDrive: char;
Begin
  If FDirectory = '' Then Result := ' '
  Else Result := UpCase(FDirectory[1]);
End;

function TFileListViewLite.GetFileName: string;
Begin
  Result := '';
  If (Selected <> Nil) And (Not (IsSysFold Or IsUnit Or IsDir Or IsNetCont)) Then
  Begin
    If IsDeskLink And FResolveLink Then
      Result := ExtractFileName(Selected.SubItems[5])
    Else Result := ExtractFileName(Selected.SubItems[4]);
  End;
End;

Function TFileListViewLite.GetFilePath: string;
Begin
  Result := '';
  If IsDeskLink And FResolveLink Then
    Result := Selected.SubItems[5]
  Else If Selected <> Nil Then
    Result := SlashSep(FDirectory, Selected.SubItems[4]);
End;

procedure TFileListViewLite.SetDrive(Value: char);
Var
  Aux: DWORD;
Begin
  if (UpCase(Value) <> Drive) Then
  Begin
    If GetDiskFreeSpace(PChar(Value + ':\'), Aux, Aux, Aux, Aux) Then
    Begin
      FDirectory := Format('%s:\', [Value]);
      ReRead;
    End;
  End;
End;

procedure TFileListViewLite.SetDirectory(NewDirectory: string);
Begin
  If AnsiCompareText(NewDirectory, FDirectory) <> 0 then
  Begin
    OldDirectory := FDirectory;
    If (NewDirectory = '\\') Then NewDirectory := 'NETWORK';
    If (UpperCase(NewDirectory) = 'DESKTOP')
      Or (UpperCase(NewDirectory) = 'DRIVES')
        Or (UpperCase(NewDirectory) = 'NETWORK')
         Or (UpperCase(NewDirectory) = 'RECYCLED') Then
    Begin
      FDirectory := NewDirectory;
      ReRead;
    End
    Else If Length(NewDirectory) > 2 Then
      Begin
        If DirectoryExists(NewDirectory) Then
        Begin
          FDirectory := NewDirectory;
          ReRead;
        End;
      End
    Else If Length(NewDirectory) > 0 Then
      SetDrive(NewDirectory[1]);
    If Assigned(FOnDirectoryChange) Then
      FOnDirectoryChange(Self, OldDirectory, FDirectory, (UpperCase(FDirectory) <> 'DESKTOP'));
    If FDirCombo <> Nil Then
      If FdirCombo.Directory <> FDirectory Then FdirCombo.Directory := FDirectory;
  End;
End;

procedure TFileListViewLite.SetFileName(NewFile: string);
Var
  FPath: String;
Begin
  If (AnsiCompareText(NewFile, GetFileName) <> 0) And FileExists(NewFile) Then
  Begin
    FPath := ExtractFileDir(NewFile);
    If FPath <> '' Then SetDirectory(FPath);
    Application.ProcessMessages;
    Selected := FindCaption(0, NewFile, True, True, True);
  End;
End;

Procedure TFileListViewLite.SetDirCombo(Value: TDirectoryComboLite);
Begin
  FDirCombo := Value;
  If FDirCombo <> nil then
  Begin
    FDirCombo.FreeNotification(Self);
    FDirCombo.Directory := FDirectory;
  End;
End;

procedure TFileListViewLite.SetFileEdit(Value: TFileNameEditLite);
Begin
  FFileEdit := Value;
  If FFileEdit <> nil then
  Begin
    FFileEdit.FreeNotification(Self);
    FFileEdit.Text := GetFileName;
  End;
End;

Procedure TFileListViewLite.SetLanguage(Value: TFileViewLanguage);
Begin
  If Value <> FLanguage then
  Begin
    FLanguage := Value;
    StrResBase := GetStringResIndex(FLanguage);    // Get Base Index for Language
    FPopupMenu.Free;
    Application.ProcessMessages;
    FPopupMenu := TFileListLitePopup.Create(Self);
    FPopupMenu.BuildItems(StrResBase);
    FPopupMenu.AutoPopup := True;
    FPopupMenu.FileListView := Self;
    PopupMenu := FPopupMenu;
    ReCreateWnd;
  End;
End;

procedure TFileListViewLite.SetFileViewType(Value: TFileListViewType);
Begin
  If Value <> FFileViewType then
  Begin
    FFileViewType := Value;
    ReRead;
  End;
End;

procedure TFileListViewLite.SetMask(NewMask: string);
Begin
  if FMask <> NewMask then
  Begin
    FMask := NewMask;
    ReRead;
  End;
End;

procedure TFileListViewLite.SetSortedBy(Value: TSortedBy);
Begin
  If Value <> FSortedBy Then
  Begin
    FSortedBy := Value;
    SortBy(Value);
  End;
End;

procedure TFileListViewLite.SetViewIconStyle(Value: TViewIconStyle);
Begin
  If Value <> FViewIconStyle Then
  Begin
    FViewIconStyle := Value;
    ViewStyle := TViewStyle(Ord(Value));
    SortBy(FSortedBy);
    If Assigned(FOnViewChange) Then FOnViewChange(Self, ViewStyle);
  End;
End;

Procedure TFileListViewLite.SetPoPupMenuEnabled(Value: Boolean);
Begin
  If Value <> FPoPupMenuEnabled Then
  Begin
    FPoPupMenuEnabled := Value;
    If FPoPupMenuEnabled Then PopupMenu := FPopupMenu
    Else PopupMenu := Nil;
  End;
End;

Function TFileListViewLite.GetViewIconStyle: TViewIconStyle;
Begin
  Result := FViewIconStyle
End;

Function TFileListViewLite.GetAllNumber: Integer;
Begin
  Result := Items.Count;
End;

Function TFileListViewLite.GetSelNumber: Integer;
Begin
  Result := SelCount;
  If Result = 0 Then Result := Items.Count;
End;

Function TFileListViewLite.GetSelSize: Integer;
Var
  I: Integer;
Begin
  Result := 0;
  If SelCount = 0 Then Result := FDirectorySize
  Else
    For I := 0 To Items.Count-1 Do
      If Items[I].Selected Then
        Result := Result + NumbToIntDef(Items[I].SubItems[0], 0);
End;


Procedure TFileListViewLite.WMDROPFILES(var Message: TWMDropFiles);
Var
  I, DropCount, BufSize: integer;
  FileName: PChar;
  Point: TPoint;
  Abort: Boolean;
  DropItem: TListItem;
  CopyDir, Aux: String;
Begin
  //If ExecutingDragFile Then Exit;
  BufSize := 0;
  FileDroppedList.Clear;
  DropCount := DragQueryFile(Message.Drop, $FFFFFFFF, Nil, BufSize);
  Try
    DragQueryPoint(Message.Drop, Point);
    For I := 0 to DropCount - 1 Do
    Begin
      BufSize := DragQueryFile(Message.Drop, I, Nil, BufSize) + 1;
      FileName := StrAlloc(BufSize + 1);
      Try
        DragQueryFile(Message.Drop, I, FileName, BufSize);
        FileDroppedList.Add(FileName);
      Finally
        StrDispose(FileName);
      End;
    End;
    DragFinish(Message.Drop);
    If DropCount > 0 Then
    Begin
      If Not IsDirReadOnly Then
      Begin
        DropItem := GetItemAt(Point.X, Point.Y);
        If DropItem = Nil Then CopyDir := FDirectory
        Else If DropItem.SubItems[3][1] = 'd' Then
        Begin
          CopyDir := SlashSep(FDirectory, DropItem.SubItems[4]);
          Selected := DropItem;
        End
        Else CopyDir := FDirectory;
        Aux := UpperCase(ExtractFileDir(FileDroppedList[0]));
        If Aux <> Uppercase(CopyDir) Then
        Begin
          DoSHFileOp(Parent.Handle, FO_COPY, FileDroppedList, CopyDir, Abort);
          //If CopyDir = FDirectory Then ReRead;
        End;
      End;
      If Assigned(FOnFileDrop) Then FOnFileDrop(FileDroppedList, Point.X, Point.Y);
    End;
  Finally
  End;
End;


{ ********************** PROTECTED OVERRIDE ******************************* }

procedure TFileListViewLite.CreateWnd;
Var
  I: Integer;
Begin
  Inherited CreateWnd;
  Columns.Clear;
  For I := 0 To 4 Do Columns.Add;
  Columns[0].Caption := LoadStr(StrResBase + 11); // 'Name';
  Columns[1].Caption := LoadStr(StrResBase + 12); // 'Size';
  Columns[2].Caption := LoadStr(StrResBase + 13); // 'Type';
  Columns[3].Caption := LoadStr(StrResBase + 14); // 'Last Modify';
  Columns[4].Caption := LoadStr(StrResBase + 15); // 'Attr';
  Columns[0].Width := 135;
  Columns[1].Width := 60;
  Columns[2].Width := 125;
  Columns[3].Width := 120;
  Columns[4].Width := 50;
  Columns[1].Alignment := taRightJustify;
  Columns[2].Alignment := taLeftJustify;
  Columns[3].Alignment := taLeftJustify;
  Columns[4].Alignment := taRightJustify;

  ColumnClick := True;
  ShowColumnHeaders := True;
  IconOptions.Arrangement := iaTop;
  IconOptions.AutoArrange := True;
  If Assigned(FOnDirectoryChange) Then
    FOnDirectoryChange(Self, '', FDirectory, (UpperCase(FDirectory) <> 'DESKTOP'));
  If FDirCombo <> Nil Then
    If FdirCombo.Directory <> FDirectory Then FdirCombo.Directory := FDirectory;
  ReRead;
End;

Procedure TFileListViewLite.Loaded;
Begin
  Inherited Loaded;
  If Not (csDesigning In ComponentState) Then
    DragAcceptFiles(Handle, True);
End;

procedure TFileListViewLite.Change(Item: TListItem; Change: Integer);
Begin
  Inherited Change(Item, Change);
  If (FFileEdit <> Nil) And (GetFileName <> '') Then
    FileEdit.Text := GetFileName;
End;

procedure TFileListViewLite.ColClick(Column: TListColumn);
Var
  I: Integer;
  SaveCursor: TCursor;
Begin
  Inherited ColClick(Column);
  If Column.Index = FLastColumnSorted Then
    FDirection := Not FDirection
  Else
  Begin
    FLastColumnSorted := Column.Index;
    FDirection := False;
  End;
  If FDirection Then
    I := Column.Index + 6
  Else I := Column.Index + 1;
  FSortedBy := TSortedBy(I-1);

  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  CustomSort(@CustomSortProc, I);
  Screen.Cursor := SaveCursor;
End;

procedure TFileListViewLite.DblClick;
Begin
  Inherited DblClick;
  If IsSysFold Then
    Directory := Selected.SubItems[4]
  Else If IsDeskLink Then
  Begin
    If FileExists(Selected.SubItems[5]) Then
      ShellOpenEx(Selected.SubItems[5], '')
    Else Directory := Selected.SubItems[5];
    If Assigned(FOnFileSelect) Then FOnFileSelect(Self, GetFilePath);
  End
  Else If IsDir Then
  Begin
    If (UpperCase(FDirectory) <> 'DESKTOP') And
        (UpperCase(FDirectory) <> 'NETWORK') Then
      Directory := SlashSep(FDirectory, Selected.SubItems[4])
    Else Directory := Selected.SubItems[4];
  End
  Else If IsUnit Then
    Directory := Selected.SubItems[4]
  Else If IsNetCont Then
    ReadNetworkResource(Selected.Data)
  Else If FExecuteOpen Then
    ShellOpen
  Else If Assigned(FOnFileSelect) Then
    FOnFileSelect(Self, GetFilePath);
End;

procedure TFileListViewLite.KeyDown(var Key: Word; Shift: TShiftState);
Begin
  Case Key of
    VK_BACK   : If not IsEditing Then PrevDirectory;
    VK_RETURN : If not IsEditing Then DblClick;
    VK_DELETE : If not IsEditing Then DeleteFiles;
    VK_F5     : If not IsEditing Then ReRead;
  End;
  Inherited KeyDown(Key, Shift);
End;

procedure TFileListViewLite.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Inherited MouseDown(Button, Shift, X, Y);
  FDragPoint := Point(X, Y);
end;

procedure TFileListViewLite.MouseMove(Shift: TShiftState; X, Y: Integer);
Var
  Res: TDragResult;
begin
  Inherited MouseMove(Shift, X, Y);
  If FDragPoint.X = -1 Then Exit;
  If (Shift <> [ssLeft]) Or (Selected = nil) Then Exit;
  If (Abs(FDragPoint.X - X) < 10) And (Abs(FDragPoint.Y - Y) < 10) Then Exit;
  If FDragFileEnabled Then
  Begin
    ExecutingDragFile := True;
    FDragPoint.X := -1;
    ReleaseCapture;
    Try
      GetSelectedFiles(DragFileInt.Files, True);
      DragFileInt.DragType := dtEither;
      Res := DragFileInt.Execute;
      Application.ProcessMessages;
      If Res <> drDropCopy Then
      Begin
        Sleep(200);
        ReRead;
      End;
    Except
    End;
    ExecutingDragFile := False;
  End;
end;

procedure TFileListViewLite.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Inherited MouseUp(Button, Shift, X, Y);
  FDragPoint.X := -1;
end;

Function TFileListViewLite.CanEdit(Item: TListItem): Boolean;
Begin
  Result := False;
  If Not IsDirReadOnly Then
  Begin
    OldName := SlashSep(FDirectory, Item.SubItems[4]);
    OldCapt := Item.Caption;
    Result := Inherited CanEdit(Item);
  End;
End;

Procedure TFileListViewLite.Edit(const Item: TLVItem);
Var
  NewName, Ext: String;
  Abort: Boolean;
Begin
  Inherited Edit(Item);
  If Selected <> Nil Then
  Begin
    Ext := ExtractFileExt(Selected.SubItems[4]);
    NewName := SlashSep(FDirectory, Selected.Caption);
    If OldCapt+Ext = Selected.SubItems[4] Then NewName := NewName + Ext;
    If Selected.Caption = '' Then
      Selected.Caption := OldCapt
    Else If UpperCase(NewName) <> UpperCase(OldName) Then
    Begin
      ChgNotifyThread.OnChangeNotify := Nil;
      FileDroppedList.Clear;
      FileDroppedList.Add(OldName);
      If Not DoSHFileOp(Parent.Handle, FO_RENAME, FileDroppedList, NewName, Abort) Then
        Selected.Caption := OldCapt
      Else
      Begin
        Items.Delete(Selected.Index);
        If Not ReadDirectoryFiles(NewName, FullFileTypes) Then
          ReadDirectoryFiles(NewName, FullFileTypes Or FILE_ATTRIBUTE_DIRECTORY);
        SortBy(FSortedBy);
      End;
      Application.ProcessMessages;
      ChgNotifyThread.ResetPendings;
      ChgNotifyThread.OnChangeNotify := ShellChangeNotify;
    End;
  End;
End;

{ *************************** PROTECTED ********************************** }

Procedure TFileListViewLite.Notification(AComponent: TComponent; Operation: TOperation);
Begin
  Inherited Notification(AComponent, Operation);
  if (Operation = opRemove) Then
  Begin
    If (AComponent = FFileEdit) Then FFileEdit := Nil;
    If (AComponent = FDirCombo) Then FDirCombo := Nil;
  End;
End;

Procedure TFileListViewLite.SortBy(SType: TSortedBy);
Var
  I: Integer;
  SaveCursor: TCursor;
Begin
  I := Ord(SType) + 1;
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  CustomSort(@CustomSortProc, I);
  Screen.Cursor := SaveCursor;
End;

Function TFileListViewLite.IsDirReadOnly: Boolean;
Begin
  Result := (UpperCase(FDirectory) = 'DESKTOP') Or
             (UpperCase(FDirectory) = 'DRIVES') Or
              (UpperCase(FDirectory) = 'NETWORK') Or
               (UpperCase(FDirectory) = 'RECYCLED');
End;

Function TFileListViewLite.IsSysFold: Boolean;
Begin
  If Selected <> Nil Then
    Result := (Selected.SubItems[3][1] = 'X')
  Else Result := False;
End;

Function TFileListViewLite.IsDeskLink: Boolean;
Begin
  If Selected <> Nil Then
    Result := (Selected.SubItems[3][1] = 'L')
  Else Result := False;
End;

Function TFileListViewLite.IsDir: Boolean;
Begin
  If Selected <> Nil Then
    Result := Selected.SubItems[3][1] = 'd'
  Else Result := False;
End;

Function TFileListViewLite.IsUnit: Boolean;
Begin
  If Selected <> Nil Then
    Result := Selected.SubItems[3][1] = 'U'
  Else Result := False;
End;

Function TFileListViewLite.IsNetCont: Boolean;
begin
  If Selected <> Nil Then
    Result := Selected.SubItems[3][1] = 'N'
  Else Result := False;
end;

Function TFileListViewLite.GetDriveTypeStr(Root: String): String;
Var
  DrvType: Integer;
Begin
  DrvType := GetDriveType(PChar(Root));
  Case DrvType Of
    0              : Result := LoadStr(StrResBase + 21); // 'Unknown';
    1              : Result := LoadStr(StrResBase + 22); // 'Not exist';
    DRIVE_REMOVABLE: Result := LoadStr(StrResBase + 23); // 'Removable Unit';
    DRIVE_FIXED	   : Result := LoadStr(StrResBase + 24); // 'Fixed Unit';
    DRIVE_REMOTE	 : Result := LoadStr(StrResBase + 25); // 'Network Unit';
    DRIVE_CDROM	   : Result := LoadStr(StrResBase + 26); // 'CD-ROM Unit';
    DRIVE_RAMDISK	 : Result := LoadStr(StrResBase + 27); // 'RAM Disk Unit';
  End;
End;

Procedure TFileListViewLite.ShellOpenEx(Com, Par: String);
Var
  Comnd, Param: Array [0..MAX_PATH] Of Char;
Begin
  If Selected <> Nil Then
  Begin
    StrPCopy(Comnd, Com);
    StrPCopy(Param, Par);
    ShellExecute(Parent.Handle, PChar('Open'), Comnd, Param, PChar(''), SW_SHOW);
  End;
End;

Procedure TFileListViewLite.SendToPath(Path: String);
Var
  Abort: Boolean;
  I: Integer;
Begin
  If Not SetCurrentDir(FDirectory) Then Exit;
  FileDroppedList.Clear;
  For I := 0 To Items.Count-1 Do
    If Items[I].Selected Then
      FileDroppedList.Add(Items[I].SubItems[4]);
  If FileDroppedList.Count > 0 Then
    DoSHFileOp(Parent.Handle, FO_COPY, FileDroppedList, Path, Abort);
End;

Procedure TFileListViewLite.ShellChangeNotify(Sender: TObject);
Begin
  ReRead;
End;

Procedure TFileListViewLite.ReadSpecialFolder(idCont, idRoot: PItemIDList; Fold: Integer; UseItem, UseDisp: Boolean);
Var
  ShFold: ISHELLFOLDER;
  EnumList: IEnumIDList;
  ShPoint: Pointer;
  idItem: PItemIDList;
  Fetched: ULONG;
  Attrib: UINT;
  sPath, sDisp: TStrRet;
  Info: TSHFileInfo;
  NewItem: TListItem;
  FileInfo: TWin32FindData;
  FindFileH: THandle;
  FSize, FDate: String;
Begin
  Fetched := 0;
  Try
    If SHGetDesktopFolder(ShFold) = NOERROR Then
    Begin
      If idCont <> Nil Then
      Begin
        If ShFold.BindToObject(idCont, Nil, IID_IShellFolder, ShPoint) = NOERROR Then
          ShFold := ISHELLFOLDER(ShPoint);
      End;
      If ShFold.BindToObject(idRoot, Nil, IID_IShellFolder, ShPoint) = NOERROR Then
        ShFold := ISHELLFOLDER(ShPoint);
      If ShFold.EnumObjects(Parent.Handle, Fold Or SHCONTF_NONFOLDERS Or SHCONTF_INCLUDEHIDDEN, EnumList) = NOERROR Then
      Begin
        EnumList.Reset;
        While EnumList.Next(1, idItem, Fetched) = NOERROR Do
        Begin
          ShFold.GetDisplayNameOf(idItem, SHGDN_FORPARSING, sPath);
          ShFold.GetDisplayNameOf(idItem, {*SHGDN_FORPARSING}{SHGDN_INFOLDER}SHGDN_NORMAL, sDisp);
          ShFold.GetAttributesOf(1, idItem, Attrib);

          NewItem := Items.Add;
          If UseItem Then
            SHGetFileInfo(PChar(idItem), 0, Info, SizeOf(Info), SHGFI_PIDL Or
                           SHGFI_SYSICONINDEX Or SHGFI_DISPLAYNAME Or SHGFI_TYPENAME)
          Else
            SHGetFileInfo({Pchar('\\ ')}sPath.cStr, 0, Info, SizeOf(Info),
                           SHGFI_SYSICONINDEX Or SHGFI_DISPLAYNAME Or SHGFI_TYPENAME);

          FindFileH := FindFirstFile(PChar(WideCharToString(sPath.pOLEStr)), FileInfo);
          If FindFileH <> INVALID_HANDLE_VALUE Then
          Begin
            FDate := FileTimeToFileDateStr(FileInfo.ftLastWriteTime);
            FSize := FormatFloat('###,###,###', (FileInfo.nFileSizeHigh * MAXDWORD) + FileInfo.nFileSizeLow);
            Windows.FindClose(FindFileH);
          End;

          If SmallImages <> Nil Then
            NewItem.ImageIndex := Info.Iicon;

          {If UseDisp Then NewItem.Caption := StrPas(Info.szDisplayName)
          Else NewItem.Caption := StrPas(sDisp.cStr);}
          If UseDisp Then NewItem.Caption := StrPas(Info.szDisplayName)
          Else NewItem.Caption := GetNiceName(SHFold, idItem, SHGDN_NORMAL);

          NewItem.Data := idItem;
          NewItem.SubItems.Add(FSize);
          NewItem.SubItems.Add(StrPas(Info.szTypeName));
          NewItem.SubItems.Add(FDate);
          NewItem.SubItems.Add(IntToStr(Attrib));
          NewItem.SubItems.Add(WideCharToString(sPath.pOLEStr));
        End;
      End;
    End;
  Except
  End;
End;

Procedure TFileListViewLite.ReadDeskTopFolder;
Var
  Info: TSHFileInfo;
  NewItem: TListItem;
  idItem: PItemIDList;
  I: Integer;
  Link, Ext: String;
  Oldcur: Tcursor;
Begin
  Oldcur := Screen.Cursor;
  Screen.Cursor := crHourglass;
  Items.BeginUpdate;
  Items.Clear;
  For I := 0 to 2 do
    If GetSHSpecialFolderInfo(Parent.Handle, Info, SysFoldid[I]) Then
    Begin
      NewItem := Items.Add;
      If SmallImages <> Nil Then
        NewItem.ImageIndex := Info.Iicon;
      NewItem.Caption := StrPas(Info.szDisplayName);
      NewItem.SubItems.Add('');
      NewItem.SubItems.Add(StrPas(Info.szTypeName));
      NewItem.SubItems.Add('');
      NewItem.SubItems.Add('X');
      NewItem.SubItems.Add(SysFoldNm[I]);
    End;
  If SHGetSpecialFolderLocation(Parent.Handle, CSIDL_DESKTOP, idItem) = NOERROR Then
  Begin
    ReadSpecialFolder(Nil, idItem, SHCONTF_FOLDERS, True, True);
    For I := Items.Count-1 DownTo 0 Do
      If FileExists(Items[I].SubItems[4]) Then
      Begin
        Ext := UpperCase(ExtractFileExt(Items[I].SubItems[4]));
        If Ext = '.LNK' Then Link := GetSHLinkedFileFromLink(Handle, Items[I].SubItems[4])
        Else Link := '';
        If Link <> '' Then
        Begin
          Items[I].SubItems[3] := 'L';
          Items[I].SubItems.Add(Link);
        End
        Else If (Ext <> '.LNK') Then
        Begin
          Items[I].SubItems[3] := 'L';
          Items[I].SubItems.Add(Items[I].SubItems[4]);
        End
        Else Items.Delete(I);
      End
      Else If (Items[I].SubItems[2] <> '') And
              ((Items[I].SubItems[3] = '64') Or (Items[I].SubItems[3] = '4')) Then
      Begin
        Items[I].SubItems[3] := 'd';
      End
      Else If Items[I].SubItems[3] <> 'X' Then Items.Delete(I);
  End;
  Items.Endupdate;
  Screen.Cursor := Oldcur;
End;

Procedure TFileListViewLite.ReadSystemResource;
Var
  MoreInfo: TSHFileInfo;
  Oldcur: Tcursor;
  NewItem: TListItem;
  Bits: Set Of 0..25;
  Ct: Integer;
  DType: Integer;
  DSize: Integer;
  Drv: Char;
Begin
  Oldcur := Screen.Cursor;
  Screen.Cursor := crHourglass;
  Items.BeginUpdate;
  Items.Clear;
  Application.ProcessMessages;
  Integer(Bits) := GetLogicalDrives;
  For Ct := 0 To 25 Do
    If (Ct In Bits) Then
    Begin
      Drv := Char(Ct + Ord('A'));
      NewItem := Items.Add;
      Try
        SHGetFileInfo(PChar(Drv + ':\'), 0, MoreInfo, SizeOf(MoreInfo),
                        SHGFI_SYSICONINDEX Or SHGFI_DISPLAYNAME Or SHGFI_TYPENAME);
        If SmallImages <> Nil Then
          NewItem.ImageIndex := MoreInfo.Iicon;
        NewItem.Caption := StrPas(MoreInfo.szDisplayName);
        DType := GetDriveType(PChar(Drv + ':\'));
        If (DType <> DRIVE_REMOVABLE) And	(DType <> DRIVE_CDROM) Then
          DSize := GetDiskSize(Drv + ':\') //DiskSize(Ct+1) Div 1024
        Else DSize := 0;
        If DSize > 10000 Then
          NewItem.SubItems.Add(FormatFloat('###,###,### Mb', DSize Div 1000))
        Else If DSize > 0 Then
          NewItem.SubItems.Add(FormatFloat('###,###,### Kb', DSize))
        Else NewItem.SubItems.Add('0 Kb');
        NewItem.SubItems.Add(GetDriveTypeStr(Drv + ':\'));
        NewItem.SubItems.Add('');
        NewItem.SubItems.Add('U');
        NewItem.SubItems.Add(Drv + ':\');
      Except
        Items.Delete(NewItem.Index);
      End;
    End;
  Items.Endupdate;
  Screen.Cursor := Oldcur;
End;

Procedure TFileListViewLite.ReadNetworkResource(idRoot: PItemIDList);
Var
  idItem: PItemIDList;
  Ret, I: Integer;
  Oldcur: Tcursor;
  NewItem : TListItem;
Begin
  Oldcur := Screen.Cursor;
  Screen.Cursor := crHourglass;
  Items.BeginUpdate;
  Items.Clear;
  If FNetWorkEnabled Then
  Begin
    Ret := SHGetSpecialFolderLocation(Parent.Handle, CSIDL_NETWORK, idItem);
    If (idRoot = Nil) And (Ret = NOERROR) Then
    Begin
      ReadSpecialFolder(Nil, idItem, SHCONTF_FOLDERS, False, False);
      For I := 0 To Items.Count-1 Do Items[I].SubItems[3] := 'N';
      Items[0].Caption := LoadStr(StrResBase + 31); // 'All The Network';
      Items[0].ImageIndex := 13;
    End
    Else If Ret = NOERROR Then
    Begin
      ReadSpecialFolder(idItem, idRoot, SHCONTF_FOLDERS, False, False);
      For I := 0 To Items.Count-1 Do
        If Pos('\\', Items[I].SubItems[4]) = 1 Then Items[I].SubItems[3] := 'd'
        Else Items[I].SubItems[3] := 'N';
    End;
  End
  Else
  Begin
    NewItem := Items.Add;
    NewItem.Caption := LoadStr(StrResBase + 31); // 'All The Network';
    NewItem.ImageIndex := 13;
    For I := 0 To 4 Do NewItem.SubItems.Add('');
    NewItem.SubItems[3] := 'N';
  End;
  Items.Endupdate;
  Screen.Cursor := Oldcur;
{var
  NetCont: TNetResource;
  PNetCnt: PNetResource;
  NetRes: Array [0..2] Of TNetResource;
  ResEnumH: THandle;
  Ret, ResCount, BufSize: DWORD;
  MoreInfo: TSHFileInfo;
  Oldcur: Tcursor;
  NewItem: TListItem;
Begin
  Oldcur := Screen.Cursor;
  Screen.Cursor := crHourglass;
  Items.BeginUpdate;
  Items.Clear;
  Application.ProcessMessages;
  BufSize := SizeOf(NetRes);
  If FDirectory = '\\' Then
    PNetCnt := Nil
  Else
  Begin
    With NetCont Do
    Begin
      dwScope := RESOURCE_CONNECTED;
      dwType := RESOURCETYPE_DISK;
      dwDisplayType := 0;
      dwUsage := 0;
      lpLocalName := '';
      lpRemoteName := PChar(FDirectory);
      lpComment := '';
      lpProvider := '';
    End;
    PNetCnt := @NetCont;
  End;
  If WNetOpenEnum(RESOURCE_GLOBALNET, RESOURCETYPE_DISK, 0, PNetCnt, ResEnumH) = NO_ERROR Then
  Begin
    ResCount := 1;
    While WNetEnumResource(ResEnumH, ResCount, @NetRes, BufSize) = NO_ERROR Do
    Begin
      ResCount := 1;
      With NetRes[0] Do
      Begin
        If lpRemoteName <> Nil Then
        Begin
          NewItem := Items.Add;
          SHGetFileInfo(PChar(lpRemoteName), 0, MoreInfo, SizeOf(MoreInfo),
                          shgfi_sysiconindex Or shgfi_smallicon Or
                          shgfi_displayname Or SHGFI_TYPENAME);
          If SmallImages <> Nil Then
            NewItem.ImageIndex := MoreInfo.Iicon;
          NewItem.Caption := StrPas(lpRemoteName);
          NewItem.SubItems.Add('0');
          NewItem.SubItems.Add(StrPas(MoreInfo.szTypeName));
          NewItem.SubItems.Add('');
          If dwUsage = RESOURCEUSAGE_CONTAINER Then
            NewItem.SubItems.Add('N')
          Else NewItem.SubItems.Add('d');
        End;
      End;
    End;
    WNetCloseEnum(ResEnumH);
  End;

  Items.Endupdate;
  Screen.Cursor := Oldcur;}
End;

Procedure TFileListViewLite.ReadRecycledBin;
Var
  idItem: PItemIDList;
  I: Integer;
  Oldcur: Tcursor;
Begin
  Oldcur := Screen.Cursor;
  Screen.Cursor := crHourglass;
  Items.BeginUpdate;
  Items.Clear;
  If SHGetSpecialFolderLocation(Parent.Handle, CSIDL_BITBUCKET, idItem) = NOERROR Then
  Begin
    ReadSpecialFolder(Nil, idItem, 0, True, False);
    For I := 0 To Items.Count-1 Do
      Items[I].SubItems[3] := LoadStr(StrResBase + 32); // 'Deleted';
  End;
  Items.Endupdate;
  Screen.Cursor := Oldcur;
End;

Function TFileListViewLite.ReadDirectoryFiles(FileMask: string; Attributes: DWORD): Boolean;
var
  NewItem : TListItem;
  Attrib: String;
  FileInfo: TWin32FindData;
  FindFileH: THandle;
  FullName: String;
  MoreInfo: TSHFileInfo;
  FName, FDate: String;
  FSize: Integer;
Begin
  Result := False;
  Try
    If UpperCase(GetCurrentDir) <> UpperCase(FDirectory) Then
      If Not SetCurrentDir(FDirectory) Then Exit;
  Except
  End;
  FDirectorySize := 0;
  FindFileH := FindFirstFile(PChar(FileMask), FileInfo);
  If FindFileH <> INVALID_HANDLE_VALUE then
  Begin
    Repeat
      With FileInfo Do
        If ((dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) =
           (Attributes And FILE_ATTRIBUTE_DIRECTORY)) And
           ((dwFileAttributes And FILE_ATTRIBUTE_READONLY) <=
           (Attributes And FILE_ATTRIBUTE_READONLY)) And
           ((dwFileAttributes And FILE_ATTRIBUTE_HIDDEN) <=
           (Attributes And FILE_ATTRIBUTE_HIDDEN)) And
           ((dwFileAttributes And FILE_ATTRIBUTE_SYSTEM) <=
           (Attributes And FILE_ATTRIBUTE_SYSTEM)) Then
        Begin
          Result := True;
          FName := StrPas(cFileName);
          If (FName <> '.') And (FName <> '..') Then
          Begin
            FDate := FileTimeToFileDateStr(ftLastWriteTime);
            NewItem := Items.Add;
            FullName := SlashSep(FDirectory, FName);

            SHGetFileInfo(PChar(FullName), 0, MoreInfo, SizeOf(MoreInfo),
                            SHGFI_SYSICONINDEX Or SHGFI_DISPLAYNAME Or SHGFI_TYPENAME);
            If SmallImages <> Nil Then
              NewItem.ImageIndex := MoreInfo.Iicon;

            If StrPas(MoreInfo.szDisplayName) = '' Then
            Begin
              NewItem.Caption := FName;
              NewItem.ImageIndex := 0;
            End
            Else NewItem.Caption := StrPas(MoreInfo.szDisplayName);

            FSize :=  (nFileSizeHigh * MAXDWORD) + nFileSizeLow;
            FDirectorySize := FDirectorySize + FSize;
            If FSize = 0 Then NewItem.SubItems.Add(' ')
            Else NewItem.SubItems.Add(FormatFloat('###,###,###,###', FSize));
            NewItem.SubItems.Add(StrPas(MoreInfo.szTypeName));
            NewItem.SubItems.Add(FDate);
            Attrib := '';
            If (dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) <> 0 Then Attrib := Attrib + 'd';
            If (dwFileAttributes And FILE_ATTRIBUTE_READONLY)  <> 0 Then Attrib := Attrib + 'r';
            If (dwFileAttributes And FILE_ATTRIBUTE_HIDDEN)    <> 0 Then Attrib := Attrib + 'h';
            If (dwFileAttributes And FILE_ATTRIBUTE_SYSTEM)    <> 0 Then Attrib := Attrib + 's';
            If (dwFileAttributes And FILE_ATTRIBUTE_ARCHIVE)   <> 0 Then Attrib := Attrib + 'a';
            Attrib := Attrib + ' ';
            NewItem.SubItems.Add(Attrib);
            NewItem.SubItems.Add(FName);

            If UpperCase(ExtractFileExt(FName)) = '.LNK' Then
              FName := GetSHLinkedFileFromLink(Handle, FullName)
            Else FName := '';
            If FName <> '' Then
            Begin
              NewItem.SubItems[3] := 'L';
              NewItem.SubItems.Add(FName);
            End
          End;
        End;
    Until Not FindNextFile(FindFileH, FileInfo);
    Windows.FindClose(FindFileH);
  End;
End;

Procedure TFileListViewLite.ReadFileNames;
Var
  SaveCursor: TCursor;
  VStyle: TViewIconStyle;
  DirAtr, FilAtr: DWORD;
  MaskPtr: PChar;
  Ptr: PChar;
Begin
  {Perform( WM_SETREDRAW, 0, 0 );}
  Items.BeginUpDate;
  Items.Clear;
  VStyle := ViewIconStyle;
  {If VStyle <> vsReport Then } ViewIconStyle := visList;
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;
  Try
    FilAtr := 0;
    If flvReadOnly In FileViewType Then FilAtr := FilAtr Or FILE_ATTRIBUTE_READONLY;
    If flvHidden   In FileViewType Then FilAtr := FilAtr Or FILE_ATTRIBUTE_HIDDEN;
    If flvSystem   In FileViewType Then FilAtr := FilAtr Or FILE_ATTRIBUTE_SYSTEM;
    DirAtr := FilAtr Or FILE_ATTRIBUTE_DIRECTORY;
    ReadDirectoryFiles(SlashSep(FDirectory, '*.*'), DirAtr);

    MaskPtr := PChar(FMask);
    While MaskPtr <> Nil Do
    Begin
      Ptr := StrScan(MaskPtr, ';');
      If Ptr <> Nil Then Ptr^ := #0;
      ReadDirectoryFiles(SlashSep(FDirectory, StrPas(MaskPtr)), FilAtr);
      If Ptr <> Nil Then
      Begin
        Ptr^ := ';';
        Inc (Ptr);
      End;
      MaskPtr := Ptr;
    End;
  Finally
    Screen.Cursor := SaveCursor;
  End;
  Items.EndUpDate;
  Application.ProcessMessages;
  {If VStyle <> vsReport Then }ViewIconStyle := VStyle;
  SortBy(FSortedBy);
  {Perform( WM_SETREDRAW, 1, 0 );}
End;


{ *************************** PUBLIC ********************************** }

Procedure TFileListViewLite.ReRead;
Begin
  If FReadEnabled Then
  Begin
    FReading := True;
    FDirectorySize := 0;
    If UpperCase(FDirectory) = 'DESKTOP' Then ReadDeskTopFolder
    Else If UpperCase(FDirectory) = 'DRIVES' Then ReadSystemResource
    Else If UpperCase(FDirectory) = 'NETWORK' Then ReadNetworkResource(Nil)
    Else If UpperCase(FDirectory) = 'RECYCLED' Then ReadRecycledBin
    Else
    Begin
      ReadFileNames;
      Application.ProcessMessages;
      If Not (csDesigning In ComponentState) Then
        ChgNotifyThread.InitMonitor(FDirectory);
    End;
    FReading := False;
    If Assigned(FOnAfterRead) Then FOnAfterRead(Self);
  End;
End;

Function TFileListViewLite.PrevDirectory: Boolean;
Var
  NewDir: String;
Begin
  If (UpperCase(FDirectory) = 'DRIVES') Or
      (UpperCase(FDirectory) = 'NETWORK') Or
       (UpperCase(FDirectory) = 'RECYCLED') Then NewDir := 'DeskTop'
  Else If UpperCase(FDirectory) <> 'DESKTOP' Then
  Begin
    NewDir := ExtractFileDir(FDirectory);
    If NewDir = FDirectory Then NewDir := 'Drives'
    Else If NewDir = '\\' Then NewDir := 'NetWork';
  End
  Else NewDir := FDirectory;

  If NewDir <> FDirectory Then Directory := NewDir;
  Application.ProcessMessages;
  Result := (UpperCase(FDirectory) <> 'DESKTOP');
End;

Procedure TFileListViewLite.Rename;
Begin
  If Selected <> Nil Then
    Selected.EditCaption;
End;

Procedure TFileListViewLite.DeleteFiles;
Var
  Abort: Boolean;
  I: Integer;
Begin
  If Not IsDirReadOnly Then
  Begin
    If Not SetCurrentDir(FDirectory) Then Exit;
    FileDroppedList.Clear;
    For I := 0 To Items.Count-1 Do
      If Items[I].Selected Then
        FileDroppedList.Add(Items[I].SubItems[4]);

    ChgNotifyThread.OnChangeNotify := Nil;

    DoSHFileOp(Parent.Handle, FO_DELETE, FileDroppedList, '', Abort);
    ReRead;

    Application.ProcessMessages;
    ChgNotifyThread.ResetPendings;
    ChgNotifyThread.OnChangeNotify := ShellChangeNotify;
  End;
End;

Procedure TFileListViewLite.NewFolder;
Var
  NewDir: String;
  I: Integer;
Begin
  If Not IsDirReadOnly Then
  Begin
    I := 2;
    NewDir := SlashSep(FDirectory, LoadStr(StrResBase + 33)); // 'New Folder');
    While DirectoryExists(NewDir) Do
    Begin
      NewDir := SlashSep(FDirectory, LoadStr(StrResBase + 33) + ' ' + IntToStr(I));
      Inc(I);
    End;
    ChgNotifyThread.OnChangeNotify := Nil;

    CreateDir(NewDir);
    ReadDirectoryFiles(NewDir, FILE_ATTRIBUTE_DIRECTORY);
    Selected := Items[Items.Count-1];
    SetFocus;

    Application.ProcessMessages;
    ChgNotifyThread.ResetPendings;
    ChgNotifyThread.OnChangeNotify := ShellChangeNotify;
    Items[Items.Count-1].EditCaption;
  End;
End;

Procedure TFileListViewLite.SendTo(Path: String);
Var
  FName: String;
Begin
  If Selected <> Nil then
  Begin
    If UpperCase(ExtractFileExt(Path)) = '.LNK' Then
    Begin
      FName := GetSHLinkedFileFromLink(Handle, Path);
      If FName <> '' Then
      Begin
        If DirectoryExists(FName) Then SendToPath(FName)
        Else ShellOpenEx(FName, GetFilePath);
      End;
    End
    Else If DirectoryExists(Path) Then SendToPath(Path)
  End;
End;

Procedure TFileListViewLite.MoveTo(Path: String);
Var
  Abort: Boolean;
  I: Integer;
Begin
  If Not SetCurrentDir(FDirectory) Then Exit;
  FileDroppedList.Clear;
  For I := 0 To Items.Count-1 Do
    If Items[I].Selected Then
      FileDroppedList.Add(Items[I].SubItems[4]);
  If FileDroppedList.Count > 0 Then
    DoSHFileOp(Parent.Handle, FO_MOVE, FileDroppedList, Path, Abort);
  //ReRead;
End;

Procedure TFileListViewLite.ShellOpen;
Begin
  If Selected <> Nil Then ShellOpenEx(GetFilePath, '');
End;

Function TFileListViewLite.GetSelectedFiles(FList: TStrings; Dir: Boolean): Integer;
Var
  I: Integer;
Begin
  FList.Clear;
  Result := 0;
  For I := 0 To Items.Count-1 Do
    With Items[I] Do
      If (Items[I].Selected)              And
         ((SubItems[3][1] <> 'd') Or Dir) And
         (SubItems[3][1] <> 'U')          And
         (SubItems[3][1] <> 'N')          And
         (SubItems[3][1] <> 'X')          Then
      Begin
        FList.Add(SlashSep(FDirectory, Caption));
        Result := Result + 1;
      End
End;



{ *************************** TFileListLitePopup ***************************** }

Constructor TFileListLitePopup.Create(AOwner: TComponent);
Begin
  Inherited Create(AOwner);
  SendToList := TStringList.Create;
End;

Procedure TFileListLitePopup.BuildItems(StrResBase: Integer);
Begin
  Items.Add(ExtNewItem(LoadStr(StrResBase + 75){'&Open'}, 0, False, True, False, 0, GeneralItemClick, 0, 'SubMenuOpen'));
  Items.Add(NewLine);
  Items.Add(ExtNewItem(LoadStr(StrResBase + 41){'&View Style'}, 0, False, True, False, 0, Nil, 0, 'SubMenuView'));
    Items.Items[2].Add(ExtNewItem(LoadStr(StrResBase + 42){'&Large icons'}, 0, False, True, True, 1, GeneralItemClick, 0, 'ItemViewIcon'));
    Items.Items[2].Add(ExtNewItem(LoadStr(StrResBase + 43){'&Small Icons'}, 0, False, True, True, 1, GeneralItemClick, 0, 'ItemViewSmal'));
    Items.Items[2].Add(ExtNewItem(LoadStr(StrResBase + 44){'&List'}, 0, False, True, True, 1, GeneralItemClick, 0, 'ItemViewList'));
    Items.Items[2].Add(ExtNewItem(LoadStr(StrResBase + 45){'&Report'}, 0, False, True, True, 1, GeneralItemClick, 0, 'ItemViewRepr'));
  Items.Add(ExtNewItem(LoadStr(StrResBase + 61){'&Sort Icons'}, 0, False, True, False, 0, Nil, 0, 'SubMenuSort'));
    Items.Items[3].Add(ExtNewItem(LoadStr(StrResBase + 62){'by &Name'}, 0, False, True, True, 2, GeneralItemClick, 0, 'ItemSortName'));
    Items.Items[3].Add(ExtNewItem(LoadStr(StrResBase + 63){'by &Size'}, 0, False, True, True, 2, GeneralItemClick, 0, 'ItemSortSize'));
    Items.Items[3].Add(ExtNewItem(LoadStr(StrResBase + 64){'by &Type'}, 0, False, True, True, 2, GeneralItemClick, 0, 'ItemSortType'));
    Items.Items[3].Add(ExtNewItem(LoadStr(StrResBase + 65){'by &Last Modify'}, 0, False, True, True, 2, GeneralItemClick, 0, 'ItemSortDate'));
    Items.Items[3].Add(ExtNewItem(LoadStr(StrResBase + 66){'by &Attributes'}, 0, False, True, True, 2, GeneralItemClick, 0, 'ItemSortAttr'));
  Items.Add(ExtNewItem(LoadStr(StrResBase + 71){'Send &To'}, 0, False, True, False, 0, Nil, 0, 'SubMenuSend'));
  GetSendTo;
  Items.Add(NewLine);
  Items.Add(ExtNewItem(LoadStr(StrResBase + 73){'&Rename'}, 0, False, True, False, 0, GeneralItemClick, 0, 'ItemOpRename'));
  Items.Add(ExtNewItem(LoadStr(StrResBase + 72){'&Delete'}, 0, False, True, False, 0, GeneralItemClick, 0, 'ItemOpDelete'));
  Items.Add(ExtNewItem(LoadStr(StrResBase + 74){'&New Folder'}, 0, False, True, False, 0, GeneralItemClick, 0, 'ItemOpFolder'));
End;

Destructor TFileListLitePopup.Destroy;
Begin
  SendToList.Free;
  Inherited Destroy;
End;

Procedure TFileListLitePopup.SetFileListView(Value: TFileListViewLite);
Begin
  FFileListView := Value;
End;

Function TFileListLitePopup.ExtNewItem(const ACaption: string; AShortCut: TShortCut;
                                        AChecked, AEnabled, ARadio: Boolean;
                                         AGroup: Integer; AOnClick: TNotifyEvent;
                                          hCtx: Word; const AName: string): TMenuItem;
Begin
  Result := NewItem(ACaption, AShortCut, AChecked, AEnabled, AOnClick, hCtx, AName);
  With Result Do
  Begin
    RadioItem := ARadio;
    GroupIndex := AGroup;
  End;

End;

Procedure TFileListLitePopup.GetSendTo;
Var
  SendToDir, FName, FullName: String;
  FileInfo: TWin32FindData;
  FindFileH: THandle;
  MoreInfo: TSHFileInfo;
  I: Integer;
  NewItem: TMenuItem;
Begin
  I := 0;
  SendToList.Clear;
  If GetSHRealPath(Handle, SendToDir, CSIDL_SENDTO) Then
  Begin
    FindFileH := FindFirstFile(PChar(SlashSep(SendToDir,'*.LNK')), FileInfo);
    If FindFileH <> INVALID_HANDLE_VALUE then
    Begin
      Repeat
        With FileInfo Do
        Begin
          FName := StrPas(cFileName);
          If (FName <> '.') And (FName <> '..') Then
          Begin
            FullName := SlashSep(SendToDir, FName);
            SHGetFileInfo(PChar(FullName), 0, MoreInfo, SizeOf(MoreInfo), SHGFI_DISPLAYNAME);
            NewItem := ExtNewItem(StrPas(MoreInfo.szDisplayName), 0,
                                False, True, True, 2, GeneralItemClick, 0, 'SendTo'+IntToStr(I));
            Items.Items[4].Add(NewItem);
            SendToList.Add(FullName);
            Inc(I);
          End;
        End;
      Until Not FindNextFile(FindFileH, FileInfo);
      Windows.FindClose(FindFileH);
    End;
  End;
End;

Procedure TFileListLitePopup.GeneralItemClick(Sender: TObject);
Var
  Idx: Integer;
Begin
  If      TMenuItem(Sender).Name = 'ItemViewList' Then FFileListView.ViewIconStyle := visList
  Else If TMenuItem(Sender).Name = 'ItemViewRepr' Then FFileListView.ViewIconStyle := visReport
  Else If TMenuItem(Sender).Name = 'ItemViewSmal' Then FFileListView.ViewIconStyle := visSmallIcon
  Else If TMenuItem(Sender).Name = 'ItemViewIcon' Then FFileListView.ViewIconStyle := visIcon

  Else If TMenuItem(Sender).Name = 'ItemSortName' Then FFileListView.SortedBy := sbName
  Else If TMenuItem(Sender).Name = 'ItemSortSize' Then FFileListView.SortedBy := sbSize
  Else If TMenuItem(Sender).Name = 'ItemSortType' Then FFileListView.SortedBy := sbType
  Else If TMenuItem(Sender).Name = 'ItemSortDate' Then FFileListView.SortedBy := sbDate
  Else If TMenuItem(Sender).Name = 'ItemSortAttr' Then FFileListView.SortedBy := sbAttr

  Else If TMenuItem(Sender).Name = 'ItemOpRename' Then FFileListView.Rename
  Else If TMenuItem(Sender).Name = 'ItemOpDelete' Then FFileListView.DeleteFiles
  Else If TMenuItem(Sender).Name = 'ItemOpFolder' Then FFileListView.NewFolder
  Else If TMenuItem(Sender).Name = 'SubMenuOpen'  Then FFileListView.ShellOpen
  Else If Pos('SendTo', TMenuItem(Sender).Name) = 1 Then
  Begin
    Idx := StrToIntDef(Copy(TMenuItem(Sender).Name, 7, 5), -1);
    If Idx > -1 Then FFileListView.SendTo(SendToList[Idx]);
  End;
End;

Procedure TFileListLitePopup.Popup(X, Y: Integer);
Var
  SortType: Integer;
Begin
  SortType := Ord(FFileListView.SortedBy);
  If SortType > 4 Then SortType := SortType - 5;

  Items[2].Items[Ord(FFileListView.ViewIconStyle)].Checked := True;
  Items[3].Items[SortType].Checked := True;

  Items[0].Visible := (FFileListView.Selected <> Nil);
  Items[1].Visible := (FFileListView.Selected <> Nil);
  Items[2].Visible := (FFileListView.Selected = Nil);
  Items[3].Visible := (FFileListView.Selected = Nil);
  Items[4].Visible := (FFileListView.Selected <> Nil);
  Items[6].Visible := (FFileListView.Selected <> Nil);
  Items[7].Visible := (FFileListView.Selected <> Nil);
  Items[8].Visible := (FFileListView.Selected = Nil);

  Inherited Popup(X, Y);
End;



{ *************************** TFileNameEditLite ****************************** }

Procedure TFileNameEditLite.SetFileListView(Value: TFileListViewLite);
Begin
  FFileListView := Value;
  If FFileListView <> nil then
    FFileListView.FreeNotification(Self);
End;

Procedure TFileNameEditLite.KeyPress(var Key: Char);
Begin
  Inherited KeyPress(Key);
  If Key = Char(VK_RETURN) Then
  Begin
    FFileListView.Mask := Text;
    Key := #0;
  End;
End;

Procedure TFileNameEditLite.Notification(AComponent: TComponent; Operation: TOperation);
Begin
  Inherited Notification(AComponent, Operation);
  If (Operation = opRemove) And (AComponent = FFileListView) Then FFileListView := nil;
End;



{ *************************** TDirectoryComboLite **************************** }

Constructor TDirectoryComboLite.Create(AOwner: TComponent);
Var
  Sfi: TShfileInfo;
Begin
  Inherited Create(AOwner);
  DirLst := TStringList.Create;
  ImageList := TImageList.Create(Self);
  Try
    ImageList.Handle :=
      SHGetFileInfo('', 0, Sfi, SizeOf(TShfileInfo),
        SHGFI_SYSICONINDEX Or SHGFI_SMALLICON);
    ImageList.ShareImages := True;
    ImageList.BlendColor := clHighlight;
  except;
  End;
  GetDir(0, FDirectory);
  Style := csOwnerDrawFixed;
  DriveItem := -1;
  ResetItemHeight;
  FOnDirectoryChange := Nil;
End;

Destructor TDirectoryComboLite.Destroy;
Begin
  DirLst.Free;
  ImageList.Free;
  Inherited Destroy;
End;

procedure TDirectoryComboLite.CreateWnd;
Begin
  inherited CreateWnd;
  BuildList;
End;

procedure TDirectoryComboLite.CMFontChanged(var Message: TMessage);
begin
  inherited;
  ResetItemHeight;
  RecreateWnd;
end;

procedure TDirectoryComboLite.CNDrawItem(var Message: TWMDrawItem);
var
  State: TOwnerDrawState;
begin
  with Message.DrawItemStruct^ do
  begin
    State := TOwnerDrawState(WordRec(LongRec(itemState).Lo).Lo);
    Canvas.Handle := hDC;
    Canvas.Font := Font;
    Canvas.Brush := Brush;
    If (Integer(itemID) >= 0) and (odSelected in State) then
    begin
      Canvas.Brush.Color := clHighlight;
      Canvas.Font.Color := clHighlightText
    end;
    If Integer(itemID) >= 0 then
      DrawItem(itemID, rcItem, State) else
      Canvas.FillRect(rcItem);
    Canvas.Handle := 0;
  end;
end;

Procedure TDirectoryComboLite.ResetItemHeight;
Var
  nuHeight: Integer;
Begin
  nuHeight :=  GetItemHeight(Font);
  if nuHeight < 16 then nuHeight := 16;
  ItemHeight := nuHeight;
End;

function TDirectoryComboLite.GetItemIndex: Integer;
begin
  Result := SendMessage(Handle, CB_GETCURSEL, 0, 0);
end;

procedure TDirectoryComboLite.SetItemIndex(Value: Integer);
begin
  SendMessage(Handle, CB_SETCURSEL, Value, 0);
  If Not InhibitItemIndex Then Click;
end;

procedure TDirectoryComboLite.DrawItem(Index: Integer; Rect: TRect; State: TOwnerDrawState);
Var
  ImageIdx, Indent: Integer;
  DispStr: String;
  SavCol: TColor;
Begin
  ImageIdx := StrToIntDef(Copy(Items[Index], 1, 4), 0);
  Indent := StrToIntDef(Copy(Items[Index], 5, 3), 0);
  DispStr := Copy(Items[Index], Pos(';', Items[Index])+1, 256);
  If (Rect.Top < ItemHeight) And (Rect.Top > 0) Then Indent := 0;
  SavCol := Canvas.Brush.Color;
  Canvas.Brush.Color := Color;
  Canvas.FillRect(Rect);
  Canvas.Brush.Color := SavCol;
  If odFocused In State Then ImageList.DrawingStyle := dsSelected
  Else ImageList.DrawingStyle := dsNormal;
  ImageList.Draw(Canvas, Rect.Left + Indent + 2,
                        (Rect.Top + Rect.Bottom - 16) Div 2, ImageIdx);
  Rect.Left := Rect.Left + Indent + 22;
  DrawText(Canvas.Handle, PChar(DispStr), -1, Rect,
             DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);
End;

procedure TDirectoryComboLite.Click;
Begin
  Inherited Click;
  Directory := Copy(Items[ItemIndex], 8, Pos(';', Items[ItemIndex])-8);
End;

procedure TDirectoryComboLite.BuildList;
var
  MoreInfo: TSHFileInfo;
  Oldcur: Tcursor;
  Bits: Set Of 0..25;
  Ct: Integer;
  Drv: Char;
Begin
  Oldcur := Screen.Cursor;
  Screen.Cursor := crHourglass;
  Items.BeginUpdate;
  Items.Clear;
  If GetSHSpecialFolderInfo(Parent.Handle, MoreInfo, CSIDL_DESKTOP) Then
      Items.Add(Format('%.4d',[MoreInfo.Iicon]) +
                '000' +
                'DeskTop;' +
                StrPas(MoreInfo.szDisplayName))
  Else Items.Add('00000DeskTop;DeskTop');
  If GetSHSpecialFolderInfo(Parent.Handle, MoreInfo, CSIDL_DRIVES) Then
      Items.Add(Format('%.4d',[MoreInfo.Iicon]) +
                '010' +
                'Drives;' +
                StrPas(MoreInfo.szDisplayName))
  Else Items.Add('00010Drives;Drives');

  Application.ProcessMessages;
  Integer(Bits) := GetLogicalDrives;
  For Ct := 0 To 25 Do
    If (Ct In Bits) Then
    Begin
      Drv := Char(Ct + Ord('A'));
      SHGetFileInfo(PChar(Drv + ':\'), 0, MoreInfo, SizeOf(MoreInfo),
                      SHGFI_SYSICONINDEX Or SHGFI_DISPLAYNAME Or SHGFI_TYPENAME);
      Items.Add(Format('%.4d',[MoreInfo.Iicon]) +
                '020' +
                Drv + ':\;' +
                StrPas(MoreInfo.szDisplayName));
    End;
  If GetSHSpecialFolderInfo(Parent.Handle, MoreInfo, CSIDL_NETWORK) Then
      Items.Add(Format('%.4d',[MoreInfo.Iicon]) +
                '010' +
                'NetWork;' +
                StrPas(MoreInfo.szDisplayName));
  // Else Items.Add('00010NetWork;NetWork');
  If GetSHSpecialFolderInfo(Parent.Handle, MoreInfo, CSIDL_BITBUCKET) Then
      Items.Add(Format('%.4d',[MoreInfo.Iicon]) +
                '010' +
                'Recycled;' +
                StrPas(MoreInfo.szDisplayName));
  // Else Items.Add('00010Recycled;Recycled');
  DisplayDir;
  Items.Endupdate;
  Screen.Cursor := Oldcur;
End;

Function TDirectoryComboLite.FindDirItem(Dir: String): Integer;
Var
  I: Integer;
Begin
  Result := -1;
  For I := 0 To Items.Count-1 Do
    If UpperCase(Copy(Items[I], 8, Pos(';', Items[I])-8)) = UpperCase(Dir) Then
    Begin
      Result := I;
      Break;
    End;
End;

procedure TDirectoryComboLite.DisplayDir;
Var
  MoreInfo: TSHFileInfo;
  I, Indent, OpenIcon: Integer;
  Root, ParDir: String;
Begin
  If DriveItem > -1 Then
  Begin
    For I := Items.Count-1 DownTo DriveItem + 1 Do
      If StrToInt(Copy(Items[I], 5, 3)) > 20 Then
        Items.Delete(I);
    DriveItem := -1
  End;
  If (UpperCase(FDirectory) = 'DESKTOP') Or
      (UpperCase(FDirectory) = 'DRIVES') Or
       (UpperCase(FDirectory) = 'NETWORK') Or
        (UpperCase(FDirectory) = 'RECYCLED') Then Root := FDirectory
  Else If FDirectory[1] = '\' Then Root := 'NetWork'
  Else Root := FDirectory[1] + ':\';
  DriveItem := FindDirItem(Root);
  ParDir := FDirectory;
  DirLst.Clear;
  While Length(ParDir) > Length(Root) Do
  Begin
    DirLst.Insert(0, ParDir);
    ParDir := ExtractFileDir(ParDir);
  End;
  Indent := 30;
  OpenIcon := 0;
  For I := 0 To DirLst.Count-1 Do
  Begin
    If I = DirLst.Count-1 Then OpenIcon := SHGFI_OPENICON;
    SHGetFileInfo(PChar(DirLst[I]), 0, MoreInfo, SizeOf(MoreInfo),
                    SHGFI_SYSICONINDEX Or OpenIcon Or SHGFI_DISPLAYNAME Or SHGFI_TYPENAME);
    Items.Insert(DriveItem+1+I, Format('%.4d',[MoreInfo.Iicon]) +
                                Format('%.3d',[Indent]) +
                                DirLst[I] + ';' +
                                StrPas(MoreInfo.szDisplayName));
    Indent := Indent + 10;
  End;
  InhibitItemIndex := True;
  ItemIndex := FindDirItem(FDirectory);
  InhibitItemIndex := False;
End;

Function TDirectoryComboLite.GetDrive: char;
Begin
  If FDirectory = '' Then Result := ' '
  Else Result := UpCase(FDirectory[1]);
End;

Procedure TDirectoryComboLite.SetDrive(Value: char);
Var
  Aux: DWORD;
Begin
  if (UpCase(Value) <> Drive) Then
  Begin
    If GetDiskFreeSpace(PChar(Value + ':\'), Aux, Aux, Aux, Aux) Then
    Begin
      FDirectory := Format('%s:\', [Value]);
      DisplayDir;
    End;
  End;
End;

Procedure TDirectoryComboLite.SetDirectory(NewDirectory: string);
Var
  OldDir: String;
Begin
  OldDir := FDirectory;
  If AnsiCompareText(NewDirectory, FDirectory) <> 0 then
  Begin
    If (NewDirectory = '\\') Then NewDirectory := 'NETWORK';
    If (UpperCase(NewDirectory) = 'DESKTOP')
      Or (UpperCase(NewDirectory) = 'DRIVES')
        Or (UpperCase(NewDirectory) = 'NETWORK')
          Or (UpperCase(NewDirectory) = 'RECYCLED') Then
    Begin
      FDirectory := NewDirectory;
      Buildlist;
    End
    Else If Length(NewDirectory) > 2 Then
      Begin
        If DirectoryExists(NewDirectory) Then
        Begin
          FDirectory := NewDirectory;
          DisplayDir;
        End;
      End
    Else If Length(NewDirectory) > 0 Then
      SetDrive(NewDirectory[1]);

    If Assigned(FOnDirectoryChange) Then
      FOnDirectoryChange(Self, OldDir, FDirectory, (UpperCase(FDirectory) <> 'DESKTOP'));
    If FFileListView <> Nil Then
      If FFileListView.Directory <> FDirectory Then FFileListView.Directory := FDirectory;
  End;
  InhibitItemIndex := True;
  ItemIndex := FindDirItem(FDirectory);
  InhibitItemIndex := False;
End;

Procedure TDirectoryComboLite.SetFileListView(Value: TFileListViewLite);
Begin
  FFileListView := Value;
  If FFileListView <> nil then
    FFileListView.FreeNotification(Self);
End;

Function TDirectoryComboLite.PrevDirectory: Boolean;
Var
  NewDir: String;
Begin
  If (UpperCase(FDirectory) = 'DRIVES') Or
      (UpperCase(FDirectory) = 'NETWORK') Or
       (UpperCase(FDirectory) = 'RECYCLED') Then NewDir := 'DeskTop'
  Else If UpperCase(FDirectory) <> 'DESKTOP' Then
  Begin
    NewDir := ExtractFileDir(FDirectory);
    If NewDir = FDirectory Then NewDir := 'Drives'
    Else If NewDir = '\\' Then NewDir := 'NetWork';
  End
  Else NewDir := FDirectory;

  If NewDir <> FDirectory Then Directory := NewDir;
  Application.ProcessMessages;
  Result := (UpperCase(FDirectory) <> 'DESKTOP');
End;

Procedure TDirectoryComboLite.Notification(AComponent: TComponent; Operation: TOperation);
Begin
  Inherited Notification(AComponent, Operation);
  If (Operation = opRemove) And (AComponent = FFileListView) Then FFileListView := nil;
End;

procedure TDirectoryComboLite.KeyDown(var Key: Word; Shift: TShiftState);
Begin
  Case Key of
    VK_BACK   : PrevDirectory;
  End;
  Inherited KeyDown(Key, Shift);
End;

End.
